/*
  Copyright (c) 2012, Matthias Schiffer <mschiffer@universe-factory.net>
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


#ifndef _FFD_FFD_H_
#define _FFD_FFD_H_

#include "util.h"


typedef enum _ffd_msg_type_t {
	MSG_UNSPEC = 0,
	MSG_SERVICE,
	MSG_ROUTE4,
	MSG_ROUTE6,
} ffd_msg_type_t;

typedef struct _ffd_msg_head_t {
	struct _ffd_msg_head_t *next;

	/* orig rev this message was added or removed last */
	uint64_t changed_rev;
	bool deleted;

	ffd_msg_type_t type;
	uint16_t len;
	uint8_t data[];
} ffd_msg_head_t;

typedef struct _ffd_orig_t {
	struct _ffd_orig_t *next;

	/* neigh rev this orig has changed last */
	uint64_t changed_rev;
	struct timespec changed_time;

	uint64_t rev;
	eth_addr_t addr;
	uint16_t orig_interval;

	ffd_msg_head_t *messages;
} ffd_orig_t;

typedef struct _ffd_neigh_t {
	struct _ffd_neigh_t *next;

	uint64_t rev;
	eth_addr_t addr;
} ffd_neigh_t;

#endif /* _FFD_FFD_H_ */
